#- Licensed Materials - Property of IBM Corp.
#- IBM UrbanCode Deploy
#- (c) Copyright IBM Corporation 2014, 2015. All Rights Reserved.
#-
#- U.S. Government Users Restricted Rights - Use, duplication or disclosure restricted by
#- GSA ADP Schedule Contract with IBM Corp.

from org.codehaus.jettison.json import JSONObject, JSONArray
import sys;
from utilities import Util

__name_att__ = None;

def _export(objid, parentrespath, name = ""):
  Util.pushPathElement('InjectionTarget')


  if parentrespath == "/":
    parentrespath = "";
  respath = "%(parentrespath)s/%(name)s" % { 'parentrespath':parentrespath, 'name':name }
  if not respath.startswith("/"):
    respath = "/" + respath;

  exportedObject = JSONObject();
  exportedObject.put("name", name);
  exportedObject.put("path", respath);
  exportedObject.put("teamMappings", JSONArray());
  exportedObject.put("inheritTeam", "true");
  exportedObject.put("description", "Discovered WebSphereInjectionTarget");
  exportedObject.put("roleName", "WebSphereInjectionTarget");

  roleProperties = JSONObject();

  Util.addAttributeToJsonIfNotNone(roleProperties, "websphere.injectiontarget.injectiontargetname", objid, "injectionTargetName","InjectionTarget");
  exportedObject.put("roleProperties", roleProperties);
  result = { 'object': exportedObject, 'respath':respath }
  extraObjects = [];
  if len(extraObjects) != 0:
    result['extraObjects'] = extraObjects;
  Util.popPathElement('InjectionTarget');
  return result;



def create(parentid, jsonobject):
  Util.pushPathElement('InjectionTarget')
  if not jsonobject.has("roleProperties"):
    raise Exception("InjectionTarget resource has no role properties!");

  roleProperties = jsonobject.getJSONObject("roleProperties");

  properties = [];
  Util.addIfNotNone(properties, "injectionTargetName", roleProperties.optString("websphere.injectiontarget.injectiontargetname", None));
  print "Creating InjectionTarget with attributes";
  for prop in properties:
    print "%(name)s = %(value)s" % { 'name': prop[0], 'value': prop[1] };
  objid = Util.create("InjectionTarget", parentid, properties);
  Util.popPathElement('InjectionTarget');

def update(objid,jsonobject):
  Util.pushPathElement('InjectionTarget')
  if not jsonobject.has("roleProperties"):
    raise Exception("InjectionTarget resource has no role properties!");

  roleProperties = jsonobject.getJSONObject("roleProperties");

  atts = [];
  Util.addAttIfChanged(objid, atts, roleProperties.optString("websphere.injectiontarget.injectiontargetname", None), "injectionTargetName","InjectionTarget");
  if len(atts) != 0:
    print "Modifying InjectionTarget with attributes:"
    for prop in atts:
      print "%(name)s = %(value)s" % { 'name': prop[0], 'value': prop[1] };

    Util.modify(objid, atts);
  else:   
    print "InjectionTarget configuration up to date.";

  Util.popPathElement('InjectionTarget');
